import java.util.*;
import java.io.*;
public class bfs
{
	static void bfsearch(ArrayList graf, int cvor, boolean[] niz, int n)
	{
		ArrayList red = new ArrayList();
		red.add(new Integer(cvor));
		niz[cvor] = true;
		while(!red.isEmpty())
		{
			int c = ((Integer)(red.get(0))).intValue();
			System.out.println("BFS je u cvoru: " + c);
			ArrayList susjedi = (ArrayList)(graf.get(c));
			for(int i=0; i<susjedi.size(); i++)
			{
				int susjed = ((Integer)(susjedi.get(i))).intValue();
				if(!niz[susjed])
				{
					System.out.println("Grana " + c + " - " + susjed + " je u pokrivajucem stablu");
					red.add(new Integer(susjed));
					niz[susjed] = true;
				}
			}
			red.remove(0);
		}
	}
	
	public static void main(String[] args)
	{
		ArrayList graf = new ArrayList();
		try
		{
			BufferedReader br = new BufferedReader(new FileReader("graf8.txt"));
			boolean eof = false;
			ArrayList mala = new ArrayList(); //ovo je ustvari lista susjeda
			while(!eof)
			{
				String line = br.readLine();
				if(line==null)
					eof = true;
				else
					if(line.compareTo("-1")==0)
					{
						graf.add(mala.clone()); //listu susjeda dodajemo listi graf
						mala.clear();
					}
					else
						mala.add(new Integer(line)); //dodajemo narednog susjeda u malu listu, tj. u listu susjeda
			}
			br.close();
		}
		catch(IOException e)
		{
			System.out.println(e.toString());
		}
		int n = graf.size();
		boolean[] niz = new boolean[n];
		for(int i=0; i<n; i++)
			niz[i] = false; //u startu nijedan susjed nije obidjen
		
		bfsearch(graf, 9, niz, n); //od nas zavisi od kog cvora cemo poceti!
	}
}