import java.util.*;
import java.io.*;
public class zad_4_bojenje_cvorova
{
	static void ispis_grafa(ArrayList g) //fja koja ispisuje graf
	{
		System.out.println("Graf ima " + g.size() + " cvorova");
		for(int i=0; i<g.size(); i++) //petlja koja ide do svakog cvora i ispisuje njegove susjede
		{
			System.out.println("Cvor " + i + " ima susjede: ");
			ArrayList susjedi = (ArrayList)(g.get(i));
			for(int j=0; j<susjedi.size(); j++)
				System.out.println(((Integer)susjedi.get(j)).intValue());
		}
	}
	
	public static void main(String[] args)
	{
		
		//lista formirana od ulazne datoteke u kojoj se cuva graf
		ArrayList graf = new ArrayList();
		try
		{
			BufferedReader br = new BufferedReader(new FileReader("graf3.txt"));
			boolean eof = false;
			ArrayList susjedi = new ArrayList(); //ovo je ustvari lista susjeda
			while(!eof)
			{
				String line = br.readLine();
				if(line==null)
					eof = true;
				else
					if(line.compareTo("-1")==0)
					{
						graf.add(susjedi.clone()); //listu susjeda dodajemo listi graf
						susjedi.clear();
					}
					else
						susjedi.add(new Integer(line)); //dodajemo narednog susjeda u malu listu, tj. u listu susjeda
			}
			br.close();
		}
		catch(IOException e)
		{
			System.out.println(e.toString());
		}
		ispis_grafa(graf);
		
		int broj_cvorova = graf.size();
		int[] boje = new int[broj_cvorova]; 
		for(int i=0; i<broj_cvorova; i++)
		{
			int boja = 0;
			ArrayList susjedi = (ArrayList)(graf.get(i));
			boolean slobodna = false;
			while(!slobodna)
			{
				boolean promjena = false;
				for(int j=0; j<susjedi.size(); j++)
				{
					int susjed = ((Integer)(susjedi.get(j))).intValue();
					if(susjed>i)
						break;
					if(boje[susjed]==boja)
					{
						boja++;
						promjena = true;
						break;
					}
				}
				if(!promjena)
				{
					boje[i] = boja;
					slobodna = true;
				}
			}
		}
		for(int i=0; i<broj_cvorova; i++)
		{
			System.out.println("Cvor " + i + " je obojen bojom:" + boje[i]);
		}
}
}