import java.io.*;
import java.util.*;
public class zad_6_bojenje_grana
{
	//fja koja provjerava dovoljan uslov za bojenje grana, tj. provjerava da li se ta boja javila u i-toj vrsti i j-toj koloni
	static boolean slobodna(int[][] A, int n, int i, int j, int k)
	{
		boolean pomocna = true;
		for(int p=0; p<n; p++)
			if((A[i][p]==k) )
			{
				pomocna = false;
				break;
			}
		
		return pomocna;
	}
	
	//fja koja boji granu i-j 
	static void oboji(int[][] A, int n, int i, int j)
	{
		int boja = 2;
		while(!slobodna(A,n,i,j,boja)) //zavrsava tek kad pronadje slobodnu boju
			boja++;
		A[i][j] = boja;
		A[j][i] = boja;
	}
	
	//ispis matrice
	static void ispis(int[][] matrica, int m, int n)
	{
		for(int i=0; i<m; i++)
		{
			for(int j=0; j<n; j++)
				System.out.print(matrica[i][j] + "\t");
				
			System.out.println();
		}
	}
	
	public static void main(String[] args)
	{
		int n = 9;
		int[][] A = new int [n][n];
		for(int i=0; i<n; i++)
			for(int j=0; j<n; j++)
				A[i][j]=0;
		try
		{
			BufferedReader br = new BufferedReader(new FileReader("graf4.txt"));
			boolean eof = false;
			int i=0; 
			int j=0;
			while(!eof)
			{
				String line = br.readLine();
				if(line==null)
					eof = true;
				else
				{
					if(line.compareTo("-1")==0)
					{
						i++; //prelazimo u novu vrstu
						j=0; //pocinjemo od prvog elementa u toj vrsti
					}
					else
					{
						j = Integer.parseInt(line);
						A[i][j] = 1;
						A[j][i] = 1;
					}
				}
			}
			br.close();
		}
		catch(IOException e)
		{
			System.out.println(e.toString());
		}
		//ispis(A,n,n);
		
		for(int i=0; i<n; i++)
			for(int j=i+1; j<n; j++)
				if(A[i][j]==1)
					oboji(A,n,i,j);
		
		ispis(A,n,n);
		
	}
	
}