import java.util.*;
import java.io.*;
import cs1.*;
public class zad_10
{
	static void dfs(ArrayList graf, int cvor, boolean[] niz, int n, int[][] A)
	{
		niz[cvor] = true; //ovim oznacavamo da je cvor obidjen
		System.out.println("Dfs se nalazi u cvoru: " + cvor);
		ArrayList susjedi = (ArrayList)(graf.get(cvor)); //uzimamo susjede cvora
		int i=0;
		while(i<susjedi.size())
		{
			int susjed = ((Integer)susjedi.get(i)).intValue();
			if(!niz[susjed]) //tj. ukoliko taj susjed nije obidjen
			{
				System.out.println("Grana " + cvor + " - " + susjed + " je u pokrivajucem stablu!");
				System.out.println();
				A[cvor][susjed]=1;
				dfs(graf, susjed, niz, n, A); //ovim pozivamoi dfs za susjeda, cime ce taj susjed biti obiljezen kao obidjen
			}
			i++;
		}
	}
	public static void main(String[] args)
	{
		System.out.println("Unesite cvor i i cvor j!");
		System.out.print("i = ");
		int i1 = Keyboard.readInt();
		System.out.print("j = ");
		int j1 = Keyboard.readInt();
		ArrayList graf = new ArrayList();
		try
		{
			BufferedReader br = new BufferedReader(new FileReader("graf9.txt"));
			boolean eof = false;
			ArrayList mala = new ArrayList(); //ovo je ustvari lista susjeda
			while(!eof)
			{
				String line = br.readLine();
				if(line==null)
					eof = true;
				else
					if(line.compareTo("-1")==0)
					{
						graf.add(mala.clone()); //listu susjeda dodajemo listi graf
						mala.clear();
					}
					else
						mala.add(new Integer(line)); //dodajemo narednog susjeda u malu listu, tj. u listu susjeda
			}
			br.close();
		}
		catch(IOException e)
		{
			System.out.println(e.toString());
		}
		int n = graf.size();
		boolean[] niz = new boolean[n];
		for(int i=0; i<n; i++)
			niz[i] = false; //u startu nijedan susjed nije obidjen
		
		int[][] A = new int[n][n];
		for(int i=0; i<n; i++)
			for(int j=0; j<n; j++)
				A[i][j]=0;
		
		dfs(graf, i1, niz, n, A); //od nas zavisi od kog cvora cemo poceti!
		
		System.out.println();
		System.out.println("Trazeni put, od cvora " + i1 + " do cvora " + j1 + " : ");
		String put = " " + j1;
		boolean uslov = true;
		int pomocni = j1;
		while(uslov)
			for(int i=0; i<n && uslov; i++)
				if(A[i][pomocni]==1)
				{
					put = " " + i + put;
					pomocni = i;
					if(i==i1)
						uslov=false;
				}	
		System.out.println(put);
	}
}