import java.io.*;
import java.util.*;
public class zad_2
{
	static void ispis_grafa(ArrayList g) //fja koja ispisuje graf
	{
		System.out.println("Graf ima " + g.size() + " cvorova");
		for(int i=0; i<g.size(); i++) //petlja koja ide do svakog cvora i ispisuje njegove susjede
		{
			System.out.println("Cvor " + i + " ima susjede: ");
			ArrayList susjedi = (ArrayList)(g.get(i));
			for(int j=0; j<susjedi.size(); j++)
				System.out.println(((Integer)susjedi.get(j)).intValue());
		}
	}
	
	static void ispis(int[][] matrica, int m, int n)
	{
		for(int i=0; i<m; i++)
		{
			for(int j=0; j<n; j++)
				System.out.print(matrica[i][j] + "\t");
				
			System.out.println();
		}
	}
	public static void main(String[] args)
	{
		
		//lista formirana od ulazne datoteke u kojoj se cuva graf
		ArrayList graf = new ArrayList();
		try
		{
			BufferedReader br = new BufferedReader(new FileReader("graf1.txt"));
			boolean eof = false;
			ArrayList susjedi = new ArrayList(); //ovo je ustvari lista susjeda
			while(!eof)
			{
				String line = br.readLine();
				if(line==null)
					eof = true;
				else
					if(line.compareTo("-1")==0)
					{
						graf.add(susjedi.clone()); //listu susjeda dodajemo listi graf
						susjedi.clear();
					}
					else
						susjedi.add(new Integer(line)); //dodajemo narednog susjeda u malu listu, tj. u listu susjeda
			}
			br.close();
		}
		catch(IOException e)
		{
			System.out.println(e.toString());
		}
		
		//matrica incidencije formirana pomocu liste
		int n = graf.size();
		int[][] matrica = new int[n][n];
		for(int i=0; i<n; i++)
			for(int j=0; j<n; j++)
			{
				ArrayList susjedi1 = (ArrayList)(graf.get(i));
				if(susjedi1.contains(new Integer(j)))
				{
					matrica [i][j] = 1;
					matrica [j][i] = 1;
				}
				else
				{
					matrica [i][j] = 0;
					matrica [j][i] = 0;
				}
			}
		ispis(matrica,n,n);
		
		//od matrice incidencije formirati listu
		ArrayList susjedi2 = new ArrayList();
		ArrayList graf1 = new ArrayList();
		for(int i=0; i<n; i++)
		{
			for(int j=0; j<n; j++)
			{
				if(matrica[i][j]==1)
					susjedi2.add(new Integer(j));
			}
			graf1.add(susjedi2.clone());
			susjedi2.clear();
		}
		ispis_grafa(graf1);
		
		//od dobijene liste formirati izlaznu datoteku koja je identicna sa ulaznom
		try
		{
			BufferedWriter bw = new BufferedWriter(new FileWriter("izlazni_graf.txt"));
			for(int i=0; i<graf1.size(); i++)
			{
				ArrayList susjedi3 = (ArrayList)(graf1.get(i));
				for(int j=0; j<susjedi3.size(); j++)
				{
					int broj = ((Integer)susjedi3.get(j)).intValue();
					bw.write(broj);
					bw.newLine();
				}
				bw.write("-1");
				bw.newLine();
			}
			bw.close();
		}
		catch(IOException e)
		{
			System.out.println(e.toString());
		}		
	}
}