import java.util.*;
import java.io.*;
public class zad_8
{
	static void dfs(ArrayList graf, int cvor, boolean[] niz, int n)
	{
		niz[cvor] = true; //ovim oznacavamo da je vcor obidjen
		System.out.println("Dfs se nalazi u cvoru: " + cvor);
		ArrayList susjedi = (ArrayList)(graf.get(cvor)); //uzimamo susjede cvora
		int i=0;
		while(i<susjedi.size())
		{
			int susjed = ((Integer)susjedi.get(i)).intValue();
			if(!niz[susjed]) //tj. ukoliko taj susjed nije obidjen
			{
				System.out.println("Grana " + cvor + " - " + susjed + " je u pokrivajucem stablu!");
				dfs(graf, susjed, niz, n); //ovim pozivamoi dfs za susjeda, cime ce taj susjed biti obiljezen kao obidjen
			}
			i++;
		}
	}
	public static void main(String[] args)
	{
		ArrayList graf = new ArrayList();
		try
		{
			BufferedReader br = new BufferedReader(new FileReader("graf7.txt"));
			boolean eof = false;
			ArrayList mala = new ArrayList(); //ovo je ustvari lista susjeda
			while(!eof)
			{
				String line = br.readLine();
				if(line==null)
					eof = true;
				else
					if(line.compareTo("-1")==0)
					{
						graf.add(mala.clone()); //listu susjeda dodajemo listi graf
						mala.clear();
					}
					else
						mala.add(new Integer(line)); //dodajemo narednog susjeda u malu listu, tj. u listu susjeda
			}
			br.close();
		}
		catch(IOException e)
		{
			System.out.println(e.toString());
		}
		int n = graf.size();
		boolean[] niz = new boolean[n];
		for(int i=0; i<n; i++)
			niz[i] = false; //u startu nijedan susjed nije obidjen
		
		dfs(graf, 0, niz, n); //od nas zavisi od kog cvora cemo poceti!
	}
}